<?php
/*
 *	函数名：numfpage
 *	说  明：分页
 *	参  数：$total 总记录数  $size 每页显示的记录数  $url 分页列表的 URL
 *	返回值：类的实例
 */
function numfpage( $total, $size=20, $url=''){
	global $paged; 
 	//默认路径
	if($url==''){
		$url_param = '?';
	    foreach ($_GET as $key => $val) {
	        if ('paged' == $key) continue;
	        if (is_array($val)) {
	            foreach ($val as $k => $v) {
	                $url_param.= "{$key}[{$k}]=$v&";
	            }
	        } else {
	            $url_param.= "$key=$val&";
	        }
	    }
		$url_param =$url= substr( $url_param, 0, -1 );
		
	}
	$result = array();
	$result['numofpage'] = $numofpage = ceil( $total / $size );
	$paged  = max( 1, intval( ($paged) ? $paged : @getgp('page') ) );

	if( $paged > $numofpage ) $paged = $numofpage;
	if( $numofpage <= 1 || !is_numeric( $paged ) ) $paged = 1;
		

		$result['limit'] = "LIMIT " . ( $paged - 1 ) * $size . ",$size";

		$pages = "<div class=\"pages\"><ul><li><a href=\"$url\" style=\"font-weight:bold\">&laquo;</a></li>";
		for( $i = $paged-4; $i <= $paged-1; $i++ ) {
			if($i < 1) continue;
			$_url = '';
			$_url = (1==$i)?'':"&paged=$i";
			$pages .= "<li><a href=\"{$url}{$_url}\">{$i}</a></li>";
		}
		$pages .= "<li><b> {$paged} </b></li>";
		if( $paged < $numofpage ){
			$flag = 0;
			for( $i = $paged+1; $i <= $numofpage; $i++ ){
				$_url = (1==$i)?'':"&paged=$i";
				$pages .= "<li><a href=\"{$url}{$_url}\">{$i}</a></li>";
				$flag++;
				if($flag==5) break;
			}
		}

		if($total > $size){
			$pages .= "<a href=\"{$url}&paged={$numofpage}\" style=\"font-weight:bold\">&raquo;</a><div class=\"fl\">Total:{$total}&nbsp; Pages:{$paged}/{$numofpage}</div><!--<span class=\"pagesone\"><input type=\"text\" size=\"3\" onkeydown=\"javascript: if(event.keyCode==13){ this.nextSibling.onclick();return false;}\" /><button onclick=\"location='{$url}'+this.previousSibling.value+'{}';return false;\" type=\"button\">GO</button></span>--></div>";
		}else{
			$pages = '';
		}
		
		$result['pages'] = $pages;
		return $result;
	
}

function getgp($key,$method=null) {
	if ($method == 'G' || $method != 'P' && isset($_GET[$key])) {
		return $_GET[$key];
	}else{
		if(is_array($_POST[$key]))
			return $_POST[$key];
		else
			return trim($_POST[$key]);
	}
	
}

function thedate_add($date, $int, $r)
{
    $rs = array(
        'year',
        'month',
        'day',
        'week',
        'hour',
        'minute',
        'second'
    );
    if (empty($date) || empty($int) || !in_array($r, $rs))
        return false;
    return date('Y-m-d H:i:s', strtotime($date . " $int $r"));
}

function mkdate($s_date, $e_date)
{
   $s_date     = strtotime($s_date);
    $e_date     = strtotime($e_date);
    $time       = $e_date - $s_date;
	$time       = $time / (3600 * 24);
	$t=$time-(int)$time;
	if($t==0)
		$res=1;
	elseif($t<0.3)
		$res=0.5;
	elseif($t>0.3)
		$res=1;
	
	return (int)$time+$res;
}

function chk_arr(&$arr)
{
    if (!is_array($arr))
        return false;
    foreach ($arr as $k => &$val) {
        if (is_array($val))
            chk_arr($val);
        else {
            if (in_array($val, array(
                "0000-00-00",
                "0000-00-00 00:00:00",
                "1970-01-01",
				"0.00"
            )))
                $arr[$k] = "";
        }
    }
    return $arr;
}
